#include <iostream>
#include <string>

using namespace std;

#include "Car5.h"

const string DUMMY_SERIAL = "ZZ00000000";

Car::Car()
{
	setSerial("");
	setPrice( 0 );
	setManufacturer( "" );
	setModel( "" );
	setSeats( 5 );	
	_ptrarrTires= createTires( );
	_ptrMotor	= createMotor( );
	
}

// using scope operator with the Constructor function...
Car::Car(string strSerial, int nPrice)
{
	// call the member function internally
	setSerial(strSerial);
	setPrice( nPrice );
	setManufacturer( "" );
	setModel( "" );
	setSeats( 5 );	
	_ptrarrTires= createTires( );
	_ptrMotor	= createMotor( );
}

Car::~Car()
{
	
	if( _ptrarrTirmes != NULL )
	{
		for( int nIndex=0; nIndex < 4; nIndex++ )
			delete _ptrarrTires[nIndex];

		delete []_ptrarrTires;
		
		_ptrarrTires= NULL;
	}

	if( _ptrMotor != NULL )
	{
		delete _ptrMotor;
		_ptrMotor = NULL;
	}

	_ptrRadio = NULL;

	cout << "Sad when a car dies!!" << endl;
}

int Car::getSeats () 
{ 
	return _nSeats; 
}

void Car::setSeats(int nSeats)
{
  if (nSeats < 0 || nSeats > 10)
    cout << "Number of seats is invalid" << endl;
  else
    _nSeats = nSeats;
}


int Car::getPrice () 
{ 
	return _nPrice; 
}
  
void Car::setPrice(int nPrice) 
{ 
	if (nPrice > 0) 
		_nPrice = nPrice; 
	else 
		_nPrice = 0; 
}

string Car::getSerial () 
{ 
	return _strSerial; 
}

void Car::setSerial (string strNewSerial)
{
	if(strNewSerial.size() == 10 && 
		isalpha(strNewSerial[0]) && 
		isalpha(strNewSerial[1]) )
			_strSerial = strNewSerial;
	else
	{
		cout << "Illegal serial: " << strNewSerial << " assigning dummy" << endl;
		_strSerial = DUMMY_SERIAL;
	}
}


string Car::getManufacturer () 
{ 
	return _strManufacturer; 
}
  
void Car::setManufacturer(string strManufacturer) 
{ 
	_strManufacturer = strManufacturer; 
}

string Car::getModel () 
{ 
	return _strModel; 
}
 
void Car::setModel(string strModel) 
{ 
	_strModel = strModel; 
}


void Car::display ()
{
  cout << "   Car data: " << endl
       << "\t Serial: " << _strSerial << endl 
       << "\t Price: " << _nPrice << endl
       << "\t Manufacturer: " << _strManufacturer << endl
       << "\t Model: " << _strModel << endl
       << "\t Seats: " << _nSeats  << endl ;
}

bool Car::gotoLocation(double dX, double dY)
{
	if( _ptrarrTires == NULL )
	{
		cout << "Can not move a car without tires, no wings!..." << endl;
		return false;
	}
	else
		for( int nIndex = 0; nIndex < 4; nIndex++ )
		{
			if(! (_ptrarrTires[nIndex]->move( ) ) )
				return false;
		}
	return true;
}

bool Car::stop()
{
	for( int nIndex = 0; nIndex < 4; nIndex++ )
		{
			if(! (_ptrarrTires[nIndex]->stop( ) ) )
				return false;
		}
	return true;
}


Motor* Car::createMotor( )
{
	Motor* ptrNewMotor;

	ptrNewMotor = new Motor( );
	ptrNewMotor->setHybrid( true );
	ptrNewMotor->setMotorSize( 2000 );
	ptrNewMotor->setCylinderCount( 4 );

	return ptrNewMotor;
}

Tire** Car::createTires( )
{
	Tire** ptrarrTires;

	ptrarrTires = new Tire*[4];
	
	ptrarrTires[0]	= new Tire( 50 );
	ptrarrTires[1]	= new Tire( 50 );
	ptrarrTires[2]	= new Tire( 55 );
	ptrarrTires[3]	= new Tire( 55 );
	
	return ptrarrTires;
}

void Car::addRadio( Radio* ptrRadio )
{
	_ptrRadio = ptrRadio;
}

Radio* Car::removeRadio( )
{
	Radio* ptrTempRadio;

	ptrTempRadio	= _ptrRadio;
	_ptrRadio		=	NULL;
	
	return ptrTempRadio;
}

bool Car::changeChannel( double dNewChannel )
{
	_ptrRadio->setChannel( dNewChannel );
	return true;
}

bool Car::turnRadioOff( )
{
	_ptrRadio->switchOn( );
	return true;
}

bool Car::turnRadioOn( )
{
	_ptrRadio->switchOff( );
	return true;
}
	 
bool gotoLocation( double dX, double dY )
{
	return true;
}

bool Car::turnCarOn( )
{
	return _ptrMotor->switchOn( );
}
	
bool Car::turnCarOff( )
{
	return _ptrMotor->switchOff( );
}
	