
#include "Tire.h"
#include "Motor.h"
#include "Radio.h"

class Car
{
 public:

	// access methods
	int getSeats ();
	void setSeats (int nSeats);
  
	int getPrice ();
	void setPrice (int nPrice);
  
	string getSerial ();
	void setSerial(string strNewSerial);

	string getManufacturer ();
	void setManufacturer (string strManufacturer);

	string getModel ();
	void setModel (string strModel);

	// prototype for the constructors...
	Car();
	Car(string strSerial, int nPrice);
	
  
	// prototype for the destructor of Car...
	~Car ();
  
	void addRadio( Radio* ptrRadio );
	Radio* removeRadio( );

	bool changeChannel( double dNewChannel );

	bool turnRadioOff( );

	bool turnRadioOn( );
	 
	bool gotoLocation( double dX, double dY );

	bool stop( );

	bool turnCarOn( );
	
	bool turnCarOff( );
	
	void display ();  


private:

	string	_strManufacturer;
	string	_strModel;
	string	_strSerial;
	int		_nSeats;
	int		_nPrice;
	Tire**	_ptrarrTires;	// a pointer to an array of pointers to 4 tires.
	Motor*	_ptrMotor;
	Radio*	_ptrRadio;

	Motor*	createMotor( );
	Tire**	createTires( );
};

